/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _fatal_error_h
#define _fatal_error_h

#define fatal_error _NI_fatal_error

#ifdef __cplusplus
extern "C" {
#endif

/*
 * fatal_error() takes a printf format & args, prints these, and
 * terminates the program.
 */
#ifdef __GNUG__
extern volatile void fatal_error(const char *, ...);
#else
extern volatile void fatal_error();
#endif

#include "../master/str_macros.h"

#ifndef assert
#ifdef NO_ASSERTIONS
#define assert(B)
#else
#ifndef assert
#define assert(B)                                                       \
{                                                                       \
    if (!(B))                                                           \
        fatal_error("assertion failed at line %d of file %s: %s\n",     \
                    __LINE__, __FILE__, STRING(B));                     \
}
#endif
#endif
#endif

#ifdef __cplusplus
}
#endif

#endif _fatal_error_h
