/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Stache source distribution
 * originally written by Alvin Lebeck and Steven K. Reinhardt and 
 * subsequently maintained by Babak Falsafi, Steven K. Reinhardt and 
 * Yannis Schoinas.
 */

#ifndef _home_h
#define _home_h

enum HomeBlkState {
    Home_Blk_Idle,
    Home_Blk_RO,
    Home_Blk_RO_BitVec,
    Home_Blk_RW,
    Home_Blk_RW_To_Home,
    Home_Blk_RO_To_Home,

    /* The following states can be changed to the corresponding */
    /* _Local_XX versions by adding Local_Get_XX_Offset */
    Home_Blk_RW_To_RO,
    Home_Blk_RW_To_RW,
    Home_Blk_RO_To_RW,
    Home_Blk_RO_To_Upgrade,

    /* _Local_RO states */
    Home_Blk_RW_To_RO_Local_RO,
    Home_Blk_RW_To_RW_Local_RO,
    Home_Blk_RO_To_RW_Local_RO,
    Home_Blk_RO_To_Upgrade_Local_RO,

    /* _Local_RW states */
    Home_Blk_RW_To_RO_Local_RW,
    Home_Blk_RW_To_RW_Local_RW,
    Home_Blk_RO_To_RW_Local_RW,
    Home_Blk_RO_To_Upgrade_Local_RW
};

#endif _home_h
