/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _tppi_internals_h
#define _tppi_internals_h

/* JS: most of them are outdated; they also depend of the protocol */
/* So, let's update them if possible. Anything else must be thrown out*/

#ifndef _common_h_
/* the following are from common.h */
#define LOG2_MAX_TARGET_NODES   5
#define MAX_TARGET_NODES        (1 << LOG2_MAX_TARGET_NODES)
#endif _common_h_

#ifndef _ipc_pn_h_
#define MAX_MSG_WORDS      1025 /* a rough approximation */
#endif _ipc_pn_h_

/* the followin two are from ipc_channels.h */
#ifndef _ipc_channels_h_
#define CHN_ID_BITS        2
#define MAX_CHANNEL_NUM    (1 << CHN_ID_BITS)
#endif _ipc_channels_h_

#endif _tppi_internals_h
