/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifdef MCS_LOCK

#include "mcs_lock.h"
#define TPPI_LOCKDEC(lockname)		MCS_LOCKDEC(lockname)
#define TPPI_LOCKINIT(lockname) 	MCS_LOCKINIT(lockname)
#define TPPI_SBRK_LOCKINIT(lockname)	MCS_SBRK_LOCKINIT(lockname)
#define TPPI_LOCK(LockPtr)		mcs_lock(LockPtr)
#define TPPI_UNLOCK(LockPtr)		mcs_unlock(LockPtr)

#else
#ifdef TAT_LOCK

#include "tat_lock.h"
#define TPPI_LOCKDEC(lockname)		TAT_LOCKDEC(lockname)
#define TPPI_LOCKINIT(lockname)		TAT_LOCKINIT(lockname)
#define TPPI_SBRK_LOCKINIT(lockname)	TAT_SBRK_LOCKINIT(lockname)
#define TPPI_LOCK(LockPtr)		tat_lock(LockPtr)
#define TPPI_UNLOCK(LockPtr)		tat_unlock(LockPtr)

#else

#include "msg_lock.h"
#define TPPI_LOCKDEC(lockname)		MSG_LOCKDEC(lockname)
#define TPPI_LOCKINIT(lockname)		MSG_LOCKINIT(lockname)
#define TPPI_SBRK_LOCKINIT(lockname)	MSG_SBRK_LOCKINIT(lockname)
#define TPPI_LOCK(LockPtr)		msg_lock(LockPtr)
#define TPPI_UNLOCK(LockPtr)		msg_unlock(LockPtr)

#endif
#endif
