/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _mach_h
#define _mach_h

extern unsigned int _mmu_pagesize;
extern unsigned int _mmu_pageshift;
extern unsigned int _mmu_pageoffset;
extern unsigned int _mmu_pagemask;

#define        MMU_PAGESIZE    4096
#define        MMU_PAGESHIFT   12
#define        MMU_PAGEOFFSET  (MMU_PAGESIZE-1)
#define        MMU_PAGEMASK    (~(MMU_PAGEOFFSET))

#define HW_BLOCK_SIZE	64
#define HW_PAGE_SIZE	4096
#define STACK_PAGE_ALIGNMENT 0x10000
#define DATA_PAGE_ALIGNMENT 0x10000

#define BLK_OFFS_MASK         (BLK_SIZE - 1)
#define BLKS_PER_PAGE         (MMU_PAGESIZE/BLK_SIZE)
#define BITS_PER_UNS          32
#define ACC_BITS_PER_BLK      2
#define LOG2_ACC_BITS_PER_BLK 1
#define ACC_BITS_MASK         0x3
#define BLKS_PER_UNS          16
#define LOG2_BLKS_PER_UNS     4


#endif
