/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _msg_lock_h
#define _msg_lock_h

#ifdef __cplusplus
extern "C" {
#endif

/* Msg passing locks for PARMACS */

typedef struct Master_Lock *LockPtr;

struct Master_Lock
{
    int master;   /* lock node */
    int lockid;   /* lock id */
};

void msg_lockinit(LockPtr *), msg_sbrk_lockinit();

/*
 * Declare a lock.
 * This pointer can be in private or shared memory as long as only one node
 * does the BLZ_LOCKINIT(lockname) and all nodes get the value from that.
 */
#define MSG_LOCKDEC(lockname)  	    LockPtr lockname;

/* Initialize a lock */
#define MSG_LOCKINIT(lockname)	    msg_lockinit(&(lockname));
/* Initialize a lock, using sbrk instead of malloc.  This is for malloc. */
#define MSG_SBRK_LOCKINIT(lockname) msg_sbrk_lockinit(&(lockname));

void msg_lock(LockPtr);
void msg_unlock(LockPtr);

#ifdef __cplusplus
}
#endif

#endif _msg_lock_h
