/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _poll_h
#define _poll_h

#include "../master/syscalls.h"
#include "../master/types.h"

#define set_poll_flag _NI_set_poll_flag

INLINE
void set_poll_flag()
{
}

#define clear_poll_flag _NI_clear_poll_flag

INLINE
void clear_poll_flag()
{
}

#define is_polling_disabled _NI_is_polling_disabled

INLINE
Uint32 is_polling_disabled()
{
    return FALSE;
}

#define enable_polling _NI_enable_polling

INLINE
void enable_polling()
{
}

#define disable_polling _NI_disable_polling

INLINE
void disable_polling()
{
}

#define set_poll_locations _NI_set_poll_locations 

INLINE
void set_poll_locations(void *a, void *b)
{
}

#define clear_poll_ownership _NI_clear_poll_ownership

INLINE
void clear_poll_ownership()
{
}

#define get_poll_ownership _NI_get_poll_ownership

INLINE
Uint32 get_poll_ownership()
{
  return ((Uint32)proc_local_area_base == 
	  get_proc_local_area_base(numComputeProcsPerNode()));
}

#define set_poll_ownership _NI_set_poll_ownership

INLINE
void set_poll_ownership(int lwp)
{
}

#endif _poll_h
