/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _addr_space_h
#define _addr_space_h

/*
 * The shared heap: allocated via shm_malloc/shm_sbrk (PARMACS G_MALLOC).
 */
#define SHARED_HEAP_BASE	(void *)(0x30000000)
#define SHARED_HEAP_MAX		(void *)(0x40000000)	/*  1/4 GB */
#define SHARED_HEAP_LEN         (((unsigned int) SHARED_HEAP_MAX) - \
				 ((unsigned int) SHARED_HEAP_BASE))

#define uncached_alias(va)  ((va) + 2 * SHARED_HEAP_LEN)
#define rw_alias(va)	    ((va) + SHARED_HEAP_LEN)
/*
 * The block access bits for blizzard_e
 * They will end up just after the uncached aliases' segment
 */

#define BLK_ACC_BIT_TBL_BASE 	 ((void *) 0x20004000)
#define SOW_BLK_ACC_BIT_TBL_BASE BLK_ACC_BIT_TBL_BASE

#define BLK_SIZE 	      64
#define LOG2_BLK_SIZE         6

#endif
