/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _lib_vm_h
#define _lib_vm_h

#include "../master/tppi_vm.h"
#include "inline.h"

#ifdef __cplusplus
extern "C" {
#endif

INLINE 
unsigned default_home(void *va)
{
    return (((unsigned)va >> TPPI_PAGE_SHIFT) % TPPI_num_nodes);
}


INLINE 
unsigned page_map_home(void *va)
{
    return (((unsigned)va >> TPPI_PAGE_SHIFT) % TPPI_num_nodes);
}

int page_map_add(char *va, int npgs, int mode);

int register_page_mode(TPPI_BlkAccFaultHandlerPtr rd_inv_handler,
		       TPPI_BlkAccFaultHandlerPtr wr_inv_handler,
		       TPPI_BlkAccFaultHandlerPtr wr_ro_handler,
		       int sizeof_user_info, int cache_mode);

int reset_page_mode_handlers(int page_mode,
                              TPPI_BlkAccFaultHandlerPtr rd_inv_handler,
                              TPPI_BlkAccFaultHandlerPtr wr_inv_handler,
                              TPPI_BlkAccFaultHandlerPtr wr_ro_handler);
  
void *alloc_shared_virtual_pages(int npgs);

void *local_shm_sbrk_mode(int nbytes, int mode);

void *shm_sbrk_mode(int nbytes, int mode);

void *local_shm_sbrk(int nbytes);

void *shm_sbrk(int nbytes);

void *shm_vsbrk(int nbytes);

#ifdef __cplusplus
}
#endif

#endif
