/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _tppi_thread_h
#define _tppi_thread_h

#include "../master/types.h"

extern int TPPI_num_threads;

#ifdef __cplusplus
extern "C" {
#endif __cplusplus

void TPPI_spin(SpinFuncPtr f, int arg);
void TPPI_sleep(volatile int *);

#define TPPI_wakeup _NI_TPPI_wakeup
#define TPPI_atomic_incr _NI_TPPI_atomic_incr
void TPPI_wakeup(volatile int *);
void TPPI_atomic_incr(volatile int *);

#ifdef __cplusplus
};
#endif __cplusplus

#endif _tppi_thread_h
