/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _user_handlers_h
#define _user_handlers_h

#include "../master/tppi_vm.h"

/*
 * This array defines the block access fault handlers.
 */


/* For second index to blz_baf_handlers table. */
#define	TPPI_ReadAccess		0
#define TPPI_WriteAccess	1 

extern TPPI_BlkAccFaultHandlerPtr blz_baf_handlers[TPPI_NUM_PAGE_MODES][TPPI_NUM_BLK_ACC_TAGS][2];

#define TPPI_register_blk_acc_fault_handler(mode,tag,acc,fn)	\
	blz_baf_handlers[mode][tag][acc] = (fn);

extern TPPI_PageFaultHandlerPtr	blz_pg_fault_handler;

#define TPPI_register_page_fault_handler(fn)	\
	blz_pg_fault_handler = (fn);

/*
 * Type for timer handler function pointers
 */
typedef void (*TPPI_TimerHandlerPtr)(void *);

#define TPPI_schedule_timer _NI_TPPI_schedule_timer

void TPPI_schedule_timer(int ticks, TPPI_TimerHandlerPtr handler, void *user_ptr);

#endif
