/*
 * Copyright (c) 1997 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 * 
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This file is part of the Blizzard source distribution
 * originally written by Babak Falsafi, Alvin Lebeck, Steven
 * K. Reinhardt, and Yannis Schoinas and subsequently maintained 
 * by Babak Falsafi, Chris Lukas, Steven K. Reinhardt, Yannis Schoinas
 * and Brian Toonen.
 */
#ifndef _vm_h
#define _vm_h

#ifdef __cplusplus
extern "C" {
#endif

#include "mach.h"
#include "../master/internals.h"
#include "../master/tppi_vm_decl.h"

extern int TPPI_num_nodes;

#define TPPI_get_page_user_ptr _NI_TPPI_get_page_user_ptr
#define TPPI_get_page_home _NI_TPPI_get_page_home
#define TPPI_get_page_mode _NI_TPPI_get_page_mode
void *TPPI_get_page_user_ptr(void *va);
TPPI_NodeId TPPI_get_page_home(void *va);
TPPI_PageMode TPPI_get_page_mode(void *va);

#define TPPI_alloc_and_map            _NI_TPPI_alloc_and_map
#define TPPI_remap                    _NI_TPPI_remap
#define TPPI_unmap_and_free           _NI_TPPI_unmap_and_free
int TPPI_alloc_and_map(void *pg, TPPI_PageMode mode, TPPI_BlkAccTag init_acc,
		       TPPI_NodeId home, void *user_ptr);
int TPPI_unmap_and_free(void *pg);
int TPPI_remap(void *old_pg, void *new_pg);

typedef struct
{
    TPPI_NodeId	   home;
    TPPI_PageMode  mode;
    void	  *user_ptr;
} TPPI_PageInfo;

#define TPPI_get_page_info _NI_TPPI_get_page_info
int TPPI_get_page_info(void *tgt_pg, TPPI_PageInfo *ptr_ptr);

#ifdef __cplusplus
}
#endif

#endif
